// IFS Dialogs
// #include <ifsafi.h>
#include "resid.h"

struct CB_item { char strvalue[10]; int intvalue; };

int SetupCB(HWND hWnd, int CB_ID, CB_item * tbl, int value)
{
    int Found = -1;
    for (int i=0; tbl[i].strvalue[0]; i++) 
      {
 	if (value == tbl[i].intvalue) Found = i; 
	SendDlgItemMessage(hWnd, CB_ID, CB_ADDSTRING, 0, (LPARAM)((LPSTR)tbl[i].strvalue));
      }
    if (Found==-1)
      {
        char temp[10];
	sprintf(temp, "+%d", value);
	SendDlgItemMessage(hWnd, CB_ID, CB_ADDSTRING, 0, (LPARAM)((LPSTR)temp));
	Found = i;
      }
    SendDlgItemMessage(hWnd, CB_ID, CB_SETCURSEL, (WPARAM)Found, 0L);
    return ++i; // number of items in list box
}

int GetCBValue(HWND hWnd, int CB_ID, CB_item * tbl, int defaultvalue)
{
    char szBuf[10];
    DWORD sel = SendDlgItemMessage(hWnd, CB_ID, CB_GETCURSEL, 0, 0L);
    if (sel == CB_ERR) return defaultvalue; // no selection was made
    for(int i=0; tbl[i].strvalue[0] && i!=sel; i++);
    if (i==sel  && tbl[i].strvalue[0]) return tbl[i].intvalue;
    SendDlgItemMessage(hWnd, CB_ID, CB_GETLBTEXT, 
    	(WPARAM) sel, (LPARAM)((LPSTR) szBuf));
    if (szBuf[0]!='+') 
      { MessageBox(hWnd, "Error in GetValue", "Error", MB_OK | MB_TASKMODAL);
        return defaultvalue; 
      }
    return (atoi(&szBuf[1]));
}

int GetCBEValue(HWND hWnd, int CB_ID, CB_item * tbl, int defaultvalue)
{
    char szBuf[10];
    DWORD sel = SendDlgItemMessage(hWnd, CB_ID, CB_GETCURSEL, 0, 0L);
    if (sel == CB_ERR)
      {  
        GetWindowText(GetDlgItem(hWnd, CB_ID), szBuf, 10); szBuf[9]=0;
	if (szBuf[0]=='+') return(atoi(&szBuf[1]));
	else return (atoi(szBuf));
      }
    for(int i=0; tbl[i].strvalue[0] && i!=sel; i++);
    if (i==sel  && tbl[i].strvalue[0]) return tbl[i].intvalue;
    SendDlgItemMessage(hWnd, CB_ID, CB_GETLBTEXT, 
    	(WPARAM) sel, (LPARAM)((LPSTR) szBuf));
    if (szBuf[0]!='+') 
      { MessageBox(hWnd, "Error in GetValue", "Error", MB_OK | MB_TASKMODAL);
        return defaultvalue; 
      }
    return (atoi(&szBuf[1]));
}

int GetCBEEValue(HWND hWnd, int CB_ID, CB_item * tbl, int defaultvalue)
{
    char szBuf[10];
    GetWindowText(GetDlgItem(hWnd, CB_ID), szBuf, 10); szBuf[9]=0;
    if (szBuf[0]=='+') return (atoi(&szBuf[1]));
    else return (atoi(szBuf));
}

void MakeCBPstr(char * szBuffer, WORD * values, int n)
{
    char tmp[10];
    szBuffer[0]=0;
    for(int i=0; i<n; i++)
    {
      if (i!=0) strcat(szBuffer, ",");
      sprintf(tmp,"%d",values[i]);
      strcat(szBuffer,tmp);
    }
}

double GetDoubleValue(char * szBuf)
// Fetch a double from szBuf and fill up with white spaces
{
    int k=0,i=0,start,end;
    char  ctemp;
    double value;
    while (szBuf[i] && isspace(szBuf[i])) ++i;
    start = i;
    while (szBuf[i] && isdigit(szBuf[i])) ++i;
    if (szBuf[i] == '.') while (szBuf[i] && isdigit(szBuf[i])) ++i;
    end = i;
    // for (i=start; i<end; i++) { buf[k++] = szBuf[i]; szBuf[i]=' '; }
    while (szBuf[i] && isspace(szBuf[i])) ++i;
    if (szBuf[i]==',') szBuf[i]=' ';
    ctemp = szBuf[i];
    szBuf[i]=0;     // terminating the string
    value = atof(&szBuf[start]);
    szBuf[i]=ctemp;  // so ok if was 0
    for(i=start; i<end; ++i) if (szBuf[i]) szBuf[i]=' ';
    return value;
}

int ParseCBPstr(char * szBuf, WORD * values, int n)
{
    char buffer[100]; 
    strcpy(buffer, szBuf);
    for(int i=0; i<n; ++i)
        values[i] = GetDoubleValue(buffer);
    return TRUE;
}

BOOL comparearray(WORD * v1, WORD * v2, int n)
{
    for (int i=0; i<n; ++i) if (v1[i]!=v2[i]) return FALSE;
    return TRUE;
}

int SetupCBP(HWND hWnd, int CB_ID, char items[][10], WORD * values, int n)
{   
    int Found = -1;
    WORD tmpvalues[10]; //assume n < 10

    for (int i=0; items[i][0]; i++) 
      {
	ParseCBPstr(items[i], tmpvalues, n);
	if (comparearray(tmpvalues, values, n)) Found = i;
	SendDlgItemMessage(hWnd, CB_ID, CB_ADDSTRING, 0, (LPARAM)((LPSTR)items[i]));
      }
    if (Found==-1)
      {
        char temp[20];
	MakeCBPstr(temp, values, n);
	SendDlgItemMessage(hWnd, CB_ID, CB_ADDSTRING, 0, (LPARAM)((LPSTR)temp));
	Found = i;
      }
    SendDlgItemMessage(hWnd, CB_ID, CB_SETCURSEL, (WPARAM)Found, 0L);
    return ++i; // number of items in list box
}

int GetCBPvalues(HWND hWnd, int CB_ID, WORD * values, int n, BOOL EditChange)
{
    char szBuf[20];
    DWORD sel = SendDlgItemMessage(hWnd, CB_ID, CB_GETCURSEL, 0, 0L);
    if (sel == CB_ERR || EditChange)
      { GetWindowText(GetDlgItem(hWnd, CB_ID), szBuf, 20); szBuf[19]=0; }
    else
      SendDlgItemMessage(hWnd, CB_ID, CB_GETLBTEXT, (WPARAM) sel, (LPARAM)((LPSTR) szBuf));
    ParseCBPstr(szBuf, values, n);
    return TRUE;
}

long PASCAL EncSettingsDlgProc(HWND hdlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    static CB_item CB_RBlockSizes[] = {{"2x2", 2}, {"4x4",4}, {"8x8", 8}, 
	      	                       {"16x16", 16}, {"32x32", 32}, {"", 0}};
    static CB_item CB_RLevels[] = {{"1 lev", 1}, {"", 0}};
    static CB_item CB_DBsteps[] = {{"1", 1}, {"2", 2}, {"4", 4}, {"8", 8},
			           {"16", 16}, {"32", 32}, {"64", 64}, {"", 0}};
    static CB_item CB_NSdiams[] = {{"10", 10}, {"20", 20}, {"60", 60}, {"100", 100},
    			           {"1000", 1000}, {"", 0}};
    static CB_item CB_LSsteps[] = {{"1", 1}, {"2", 2}, {"4", 4}, {"8", 8}, {"", 0}};
    static char CB_QPbits[][10] = {"16,16,16", "8,8,8", "8,6,6", "8,4,4", "7,6,6", 
				   "7,4,4", "6,5,5",  "4,2,2", "4,1,1", "" };
    static class Kernel KernelBack;
	HFONT hfontDlg;
	LOGFONT lFont;


    int index;
    char strtmp[255];
    switch (message)
      {
	case WM_INITDIALOG:
	    KernelBack = Kernel;
	    // Range blocks
	      SetupCB(hdlg, ID_RBsize, CB_RBlockSizes, Kernel.B);

	    // Recursion levels
	      SetupCB(hdlg, ID_RLdepth, CB_RLevels, Kernel.MaxLevel);

	    // Domain Pool  : we assume did == djd
	      SetupCB(hdlg, ID_DBstep, CB_DBsteps, Kernel.did);
	      sprintf(strtmp, "%dx%d", Kernel.B*2, Kernel.B*2);
	      SetWindowText(GetDlgItem(hdlg,ID_DBsize), strtmp);
	    
	    // NeightBoorhood  search :  radius/diam
	      SendDlgItemMessage(hdlg, ID_NSEn, BM_SETCHECK, 1, 0L);
	      EnableWindow(GetDlgItem(hdlg, ID_NSEn), FALSE);
	      SetupCB(hdlg, ID_NSdiam, CB_NSdiams, Kernel.radius);
	      EnableWindow(GetDlgItem(hdlg, ID_NSdiam), TRUE);

	    // Local Sub Search
	      SendDlgItemMessage(hdlg, ID_LSEn, BM_SETCHECK, Kernel.ENC_OVERSTEP, 0L);
	      SetupCB(hdlg, ID_LSstep, CB_LSsteps, Kernel.overstep);
	      EnableWindow(GetDlgItem(hdlg, ID_LSstep), Kernel.ENC_OVERSTEP);

	    // Quantize Params
	      SendDlgItemMessage(hdlg, ID_QPEn, BM_SETCHECK, Kernel.ENC_QUANTIZEALPHA, 0L);
	      SetupCBP(hdlg, ID_QPalpha, CB_QPbits, &Kernel.quantizebits[ALPHAY], 3);
	      SetupCBP(hdlg, ID_QPbeta,  CB_QPbits, &Kernel.quantizebits[BETAY], 3);
	      EnableWindow(GetDlgItem(hdlg, ID_QPalpha), Kernel.ENC_QUANTIZEALPHA);
	      EnableWindow(GetDlgItem(hdlg, ID_QPbeta), Kernel.ENC_QUANTIZEALPHA);
	      EnableWindow(GetDlgItem(hdlg, ID_QPequ), Kernel.ENC_QUANTIZEALPHA);

	    // Use polynomials
	      SendDlgItemMessage(hdlg, ID_PLYEn, BM_SETCHECK, 0, 0L);
	      EnableWindow(GetDlgItem(hdlg, ID_PLYEn), 0);
	      EnableWindow(GetDlgItem(hdlg, ID_PLYonly), 0);
	      EnableWindow(GetDlgItem(hdlg, ID_PLYstrip), 0);
	      EnableWindow(GetDlgItem(hdlg, ID_PLYYbit), 0);
	      EnableWindow(GetDlgItem(hdlg, ID_PLYIbit), 0);
	      EnableWindow(GetDlgItem(hdlg, ID_PLYQbit), 0);
	      EnableWindow(GetDlgItem(hdlg, ID_PLYequ), 0);

	     // Isometries
	       SendDlgItemMessage(hdlg, ID_ISOall, BM_SETCHECK, (Kernel.ENC_USEORIENTATIONSCHEME == FALSE), 0L);
	       SendDlgItemMessage(hdlg, ID_ISOpred,BM_SETCHECK, (Kernel.ENC_USEORIENTATIONSCHEME == TRUE), 0L);
	       SendDlgItemMessage(hdlg, ID_ISOLSEn, BM_SETCHECK, Kernel.ENC_OVERSTEPUSEISOMETRIES, 0L);

      hfontDlg = (HFONT) NULL;
      if ((hfontDlg = (HFONT) SendMessage(hdlg, WM_GETFONT, 0, 0L))) {
        if (GetObject(hfontDlg, sizeof(LOGFONT), (LPSTR) &lFont)) {
          lFont.lfWeight = FW_NORMAL;
          if (hfontDlg = CreateFontIndirect((LPLOGFONT) &lFont)) {
            SendDlgItemMessage(hdlg, ID_RBsize, WM_SETFONT,(WPARAM) hfontDlg, 0); 
            SendDlgItemMessage(hdlg, ID_DBstep, WM_SETFONT,(WPARAM) hfontDlg, 0); 
            SendDlgItemMessage(hdlg, ID_NSEn, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_NSEn, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_NSdiam, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_LSEn, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_LSstep, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_RLdepth, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYEn, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYonly, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYstrip, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYYbit, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYIbit, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYQbit, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYequ, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_ISOall, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_ISOpred, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_ISOLSEn, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_QPalpha, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_QPbeta, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_QPequ, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_QPEn, WM_SETFONT,(WPARAM) hfontDlg, 0);

            SendDlgItemMessage(hdlg, ID_RBttl, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_RBtxt1, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_RLttl, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_RLtxt1, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_DBttl, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_DBsize, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_DBtxt1, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_DBtxt2, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_DBtxt3, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_NStxt1, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_NStxt2, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_LStxt1, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYtxt1, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_PLYtxt2, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_QPtxt1, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_QPtxt2, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_QPtxt3, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, ID_ISOttl, WM_SETFONT,(WPARAM) hfontDlg, 0);
			
			SendDlgItemMessage(hdlg, IDDEFAULT, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, IDCANCEL, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, IDHELP, WM_SETFONT,(WPARAM) hfontDlg, 0);
			}
           }
         }
	    return TRUE;

	    return TRUE;

    case WM_CTLCOLORDLG:
	//case WM_CTLCOLOREDIT:
	case WM_CTLCOLORSTATIC:
	case WM_CTLCOLORBTN:
	        //MessageBox(NULL, "CTLcolor","",MB_OK|MB_TASKMODAL);
			SetBkColor((HDC)((wParam)),  GetSysColor(COLOR_BTNFACE));
			//SetTextColor((HDC)((wParam)), GetSysColor(COLOR_WINDOWTEXT));
			//SetBkMode((HDC)((wParam)), TRANSPARENT);

			// UnrealizeObject(hbrBackground);
		return (DWORD) hbrBackground;

	case WM_SYSCOLORCHANGE:
	    DeleteObject(hbrBackground);
	    hbrBackground = CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
		return 0;

	case WM_COMMAND:
	    switch (LOWORD(wParam))  // need LOWORD for NT,95
	      {		
		case ID_RBsize:
		    //HIWORD(lParam) for Win3.1x
		    //HIWORD(wParam) for NT,95
		    if (HIWORD(wParam) == CBN_SELCHANGE)
		      {
		         Kernel.B = GetCBValue(hdlg, ID_RBsize, CB_RBlockSizes, Kernel.B);
			 sprintf(strtmp, "%dx%d", Kernel.B*2, Kernel.B*2);
	      	  	 SetWindowText(GetDlgItem(hdlg,ID_DBsize), strtmp);
		      }
		    return TRUE;
		case ID_RLdepth:
		    if (HIWORD(wParam) == CBN_SELCHANGE)
		        Kernel.MaxLevel = GetCBValue(hdlg, ID_RLdepth, CB_RLevels, Kernel.MaxLevel);
		    return TRUE;
		case ID_DBstep:
		    if (HIWORD(wParam) == CBN_SELCHANGE)
		         Kernel.did = Kernel.djd = GetCBValue(hdlg, ID_DBstep, CB_DBsteps, Kernel.did);
		    return TRUE;
		case ID_NSdiam:
		    if (HIWORD(wParam) == CBN_SELCHANGE)
		         Kernel.radius = GetCBEValue(hdlg, ID_NSdiam, CB_NSdiams, Kernel.radius);
		    else 
		    if (HIWORD(wParam) == CBN_EDITCHANGE)
			 Kernel.radius = GetCBEEValue(hdlg, ID_NSdiam, CB_NSdiams, Kernel.radius);
		    return TRUE;
	 	case ID_LSEn:
		    if (HIWORD(wParam) == BN_CLICKED)
		      {
		        if (Kernel.ENC_OVERSTEP = SendDlgItemMessage(hdlg, ID_LSEn, BM_GETCHECK, 0, 0L))
			    EnableWindow(GetDlgItem(hdlg, ID_LSstep), TRUE);
			 else 
			    EnableWindow(GetDlgItem(hdlg, ID_LSstep), FALSE);
		      }
		    return TRUE;
		case ID_LSstep:
		    if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_EDITCHANGE )
		      {
		        Kernel.overstep = GetCBEValue(hdlg, ID_LSstep, CB_LSsteps, Kernel.overstep);			
		      }
		     return TRUE;
		case ID_QPEn:
		    if (HIWORD(wParam) == BN_CLICKED)
		      {
		        BOOL EN = ( Kernel.ENC_QUANTIZEALPHA = SendDlgItemMessage(hdlg, ID_QPEn, BM_GETCHECK, 0, 0L));
	      		EnableWindow(GetDlgItem(hdlg, ID_QPalpha), EN);
	      		EnableWindow(GetDlgItem(hdlg, ID_QPbeta), EN);
	      		EnableWindow(GetDlgItem(hdlg, ID_QPequ), EN);
		      }
		    return TRUE;
		case ID_QPalpha:
		    if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_EDITCHANGE )
		        GetCBPvalues(hdlg, ID_QPalpha, &Kernel.quantizebits[ALPHAY], 3, HIWORD(wParam)==CBN_EDITCHANGE);
		    return TRUE;
		case ID_QPbeta:
		    if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_EDITCHANGE )
		        GetCBPvalues(hdlg, ID_QPbeta, &Kernel.quantizebits[BETAY], 3, HIWORD(wParam)==CBN_EDITCHANGE);
		    return TRUE;
		case ID_QPequ:		    
		    GetWindowText(GetDlgItem(hdlg, ID_QPalpha), strtmp, 100);
		    SetWindowText(GetDlgItem(hdlg, ID_QPbeta), strtmp);
		    GetCBPvalues(hdlg, ID_QPbeta, &Kernel.quantizebits[BETAY], 3, TRUE);
		    return TRUE;
		case ID_ISOall:
		    if (HIWORD(wParam) == BN_CLICKED)
		      Kernel.ENC_USEORIENTATIONSCHEME = !SendDlgItemMessage(hdlg, ID_ISOall, BM_GETCHECK, 0, 0L);
		    return TRUE;
		case ID_ISOpred:
		    if (HIWORD(wParam) == BN_CLICKED)
		      Kernel.ENC_USEORIENTATIONSCHEME = SendDlgItemMessage(hdlg, ID_ISOpred, BM_GETCHECK, 0, 0L);
		    return TRUE;
		case ID_ISOLSEn:
		    if (HIWORD(wParam) == BN_CLICKED)
		      Kernel.ENC_OVERSTEPUSEISOMETRIES = SendDlgItemMessage(hdlg, ID_ISOLSEn, BM_GETCHECK, 0, 0L);
		    return TRUE;
		case IDOK: 
		    EndDialog(hdlg, TRUE);
		    return TRUE;
		case IDCANCEL:
		    Kernel = KernelBack;
		    EndDialog(hdlg, FALSE);
		    return TRUE;
		case IDDEFAULT:  // may be a drop down menu, INI, bi, last..
		    {
		      // class Kernel KernelDefault;
		      // Kernel = KernelDefault;
		      // here we have to update all controls...
		    }
		    return TRUE;		    
	      }
	    break;
      }
    return FALSE;
}


static OPENFILENAME sifn;
static char szStartingTitleName[1024];

void InitializeDlgBrowse(HWND hwnd, OPENFILENAME & ofn)
{
  static char * szFilter[] = { "BMP RGB Encoded", "*.bmp", "" };
  ofn.lStructSize       = sizeof(OPENFILENAME);
  ofn.hwndOwner         = hwnd;
  ofn.hInstance         = NULL;
  ofn.lpstrFilter       = szFilter[0];
  // ofn.nFilterIndex      = 1;
  ofn.lpstrCustomFilter = 0;
  ofn.nMaxCustFilter    = 0;
  ofn.lpstrFile         = NULL;
  ofn.nMaxFile          = _MAX_PATH;
  ofn.lpstrFileTitle    = NULL;
  ofn.nMaxFileTitle     = _MAX_FNAME + _MAX_EXT;
  ofn.lpstrInitialDir   = NULL;
  ofn.lpstrTitle        = NULL;
  ofn.Flags             = 0;
  ofn.nFileOffset       = 0;
  ofn.nFileExtension    = 0;
  ofn.lpstrDefExt       = "bmp";
  ofn.lCustData         = 0l;
  ofn.lpfnHook          = NULL;
  ofn.lpTemplateName    = NULL;
}

BOOL InputFileDlgBrowse(HWND hwnd, LPSTR lpstrFileName, LPSTR lpstrTitleName)
{

    sifn.hwndOwner       = hwnd; 
    sifn.lpstrFile       = lpstrFileName;
    sifn.lpstrFileTitle  = lpstrTitleName;
    sifn.Flags           = OFN_FILEMUSTEXIST;
    return GetOpenFileName( &sifn );
}



long PASCAL DecSettingsDlgProc(HWND hdlg, UINT message, WPARAM wParam, LPARAM lParam)
{				 
    static CB_item CB_DECsteps[] = {{"3",3}, {"5",5}, {"6",6}, {"7",7}, {"8",8},
				   {"9",9}, {"10",10}, {"", 0}};
    static class Kernel KernelBack;
	HFONT hfontDlg;
	LOGFONT lFont;
    
    int index;
    char strtmp[255];
    switch (message)
      {
	case WM_INITDIALOG:
	    KernelBack = Kernel;
	      InitializeDlgBrowse(hdlg, sifn);
	      SetupCB(hdlg, ID_DECsteps, CB_DECsteps, Kernel.decsteps);
	      SendDlgItemMessage(hdlg, ID_AUTOsave, BM_SETCHECK, TRUE, 0L);
	      EnableWindow(GetDlgItem(hdlg, ID_AUTOsave), FALSE);
	      SendDlgItemMessage(hdlg, ID_STEPsave, BM_SETCHECK, Kernel.DEC_SAVESTEPS, 0L);

	      SendDlgItemMessage(hdlg, ID_STARTimage, BM_SETCHECK, szStartingFileName[0], 0L);
	      SetWindowText(GetDlgItem(hdlg, ID_STARTname), szStartingFileName);
	      EnableWindow(GetDlgItem(hdlg, ID_STARTname), szStartingFileName[0]);
	      EnableWindow(GetDlgItem(hdlg, IDBROWSE), szStartingFileName[0]);

      hfontDlg = (HFONT) NULL;
      if ((hfontDlg = (HFONT) SendMessage(hdlg, WM_GETFONT, 0, 0L))) {
        if (GetObject(hfontDlg, sizeof(LOGFONT), (LPSTR) &lFont)) {
          lFont.lfWeight = FW_NORMAL;
          if (hfontDlg = CreateFontIndirect((LPLOGFONT) &lFont)) {
            SendDlgItemMessage(hdlg, ID_DECsteps, WM_SETFONT,(WPARAM) hfontDlg, 0); // About
            SendDlgItemMessage(hdlg, ID_AUTOsave, WM_SETFONT,(WPARAM) hfontDlg, 0); // About
            SendDlgItemMessage(hdlg, ID_STEPsave, WM_SETFONT,(WPARAM) hfontDlg, 0); // Encoding (.)
            SendDlgItemMessage(hdlg, ID_DECtxt1, WM_SETFONT,(WPARAM) hfontDlg, 0); // About
            SendDlgItemMessage(hdlg, ID_STARTname, WM_SETFONT,(WPARAM) hfontDlg, 0); // Encoding (.)
            SendDlgItemMessage(hdlg, ID_STARTimage, WM_SETFONT,(WPARAM) hfontDlg, 0); // Decoding (.)
            //SendDlgItemMessage(hdlg, IDOK, WM_SETFONT,(WPARAM) hfontDlg, 0); // Browse Input
            SendDlgItemMessage(hdlg, IDBROWSE, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, IDDEFAULT, WM_SETFONT,(WPARAM) hfontDlg, 0);
            SendDlgItemMessage(hdlg, IDCANCEL, WM_SETFONT,(WPARAM) hfontDlg, 0); // Browse Input
            SendDlgItemMessage(hdlg, IDHELP, WM_SETFONT,(WPARAM) hfontDlg, 0);
            }
           }
         }
	    return TRUE;

    case WM_CTLCOLORDLG:
	//case WM_CTLCOLOREDIT:
	case WM_CTLCOLORSTATIC:
	case WM_CTLCOLORBTN:
	        //MessageBox(NULL, "CTLcolor","",MB_OK|MB_TASKMODAL);
			SetBkColor((HDC)((wParam)),  GetSysColor(COLOR_BTNFACE));
			//SetTextColor((HDC)((wParam)), GetSysColor(COLOR_WINDOWTEXT));
			//SetBkMode((HDC)((wParam)), TRANSPARENT);

			// UnrealizeObject(hbrBackground);
		return (DWORD) hbrBackground;

	case WM_SYSCOLORCHANGE:
	    DeleteObject(hbrBackground);
	    hbrBackground = CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
		return 0;

	case WM_COMMAND:
	    switch (LOWORD(wParam))  // need LOWORD for NT,95
	      {		
		case ID_DECsteps:
		    if (HIWORD(wParam) == CBN_SELCHANGE || HIWORD(wParam) == CBN_EDITCHANGE )
		         Kernel.decsteps = GetCBEValue(hdlg, ID_DECsteps, CB_DECsteps, Kernel.decsteps);
		    return TRUE;
		case ID_STEPsave:
		    if (HIWORD(wParam) == BN_CLICKED)
		      Kernel.DEC_SAVESTEPS = SendDlgItemMessage(hdlg, ID_STEPsave, BM_GETCHECK, 0, 0L);
		    return TRUE;
		case ID_STARTimage:
		    if (HIWORD(wParam) == BN_CLICKED)
		    {
		      index = SendDlgItemMessage(hdlg, ID_STARTimage, BM_GETCHECK, 0, 0L);
		      EnableWindow(GetDlgItem(hdlg, ID_STARTname), index);
		      EnableWindow(GetDlgItem(hdlg, IDBROWSE), index);
		    }
		    return TRUE;
		case ID_STARTname:
		    if (HIWORD(wParam) == CBN_EDITCHANGE)
		      GetWindowText(GetDlgItem(hdlg, ID_STARTname), szStartingFileName, _MAX_PATH);
		    return TRUE;
		case IDBROWSE:
		    GetWindowText(GetDlgItem(hdlg, ID_STARTname), szStartingFileName, _MAX_PATH);
		    szStartingTitleName[0] = '\0';
		    if (InputFileDlgBrowse(hdlg, szStartingFileName, szStartingTitleName))
		       SetWindowText(GetDlgItem(hdlg, ID_STARTname), szStartingFileName);
		    return TRUE;     
		case IDOK: 
		    EndDialog(hdlg, TRUE);
		    return TRUE;
		case IDCANCEL:
		    Kernel = KernelBack;
		    EndDialog(hdlg, FALSE);
		    return TRUE;
		case IDDEFAULT:  // may be a drop down menu, INI, bi, last..
		    return TRUE;		    
	      }
	    break;
      }
    return FALSE;
}
