// File: krnldef.h
// Definitions of datatypes (for non-including windows.h files)
// Written by G.Pulcini
// Revision:
//      1.10 - Oct 1995 - NT port
//      1.01 - Jan 1995

/*
   Here we define the following types
   DWORD 32 bits unsigned
   WORD  16 bits unsigned
   BYTE   8 bits unsigned
   BOOL  boolean (int)
     TRUE  1
     FALSE 0

   And the following macros
   MAX
   MIN

   We also include file _defs.h
   _CLASSDEF
   ...
*/


#ifndef __KRNLDEF_H__
#define __KRNLDEF_H__

/*
#ifndef BOOL
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned int        WORD;
typedef unsigned long       DWORD;
#endif
*/

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef MAX
#define MAX(a,b) ((a)>(b) ? (a):(b))
#endif
#ifndef MIN
#define MIN(a,b) ((a)<(b) ? (a):(b))
#endif

#ifndef PTBLOCK
#define PTBLOCK BYTE  *
#endif
#ifndef THistogram
typedef DWORD THistogram[256];
#endif

/*
#if !defined(__DEFS_H)
#include <_defs.h>
#endif
*/

#  define _CLASSTYPE 
#  define _PTRDEF(name) typedef name * P##name;
#  define _REFDEF(name) typedef name & R##name;
#  define _REFPTRDEF(name) typedef name * & RP##name;
#  define _PTRCONSTDEF(name) typedef const name * PC##name;
#  define _REFCONSTDEF(name) typedef const name & RC##name;
#  define _CLASSDEF(name) class _CLASSTYPE name; \
        _PTRDEF(name) \
    _REFDEF(name) \
    _REFPTRDEF(name) \
    _PTRCONSTDEF(name) \
    _REFCONSTDEF(name)

#endif
