// file: mathkrnl.h
// Matrix manipulation routines
// Written by G.Pulcini
// Last revised 1995/2/26 Rev. 2.0

#ifndef __MATHKRNL_H__
#define __MATHKRNL_H__

#ifndef __KRNLDEF_H__
#include "krnldef.h"
#endif

#ifndef __MATH_H
#include <math.h>
#endif

/*
#ifndef WORD
  typedef unsigned int WORD;
#endif
*/

#ifndef NULL
  #define NULL 0ul
#endif


int CountBits(WORD cmap);
void CalcBasis(WORD cmap, double ** basis, int rows, int cols);
double Dot(int n, double * v1, double * v2, double * w = NULL);
void StripFromList(int * l1, int * l2, int i0, int n = -1);
int len(int * l1);
double Minor(int * I, int * J, double ** A);
double Det(double ** A, int n);
void Inverse(double ** A, double ** B, int n);
void PseudoInverse(double ** A, double ** B, int n);
DWORD fpStatistics(int n);

void MakeBasisVectors();

#endif

