// file: msgbox.h
// Defines MsgBox(Title, Format, ...)
// Environment: Windows 3.11
// Portability: Middle
// Author: G.Pulcini
// Revision: 0.3 of 17-01-1995

/*
  User must respond to the msgbox before application could continue.
  Other application may be used, but no window of current application
  should be used before answering the dialog.
  See MB_TASKMODAL on HELP for more details.
*/

#ifndef __MSGBOX_H__
#define __MSGBOX_H__

//#include <owl.h>
#ifndef __WINDOWS_H
#include <windows.h>
#endif

#ifndef __STDIO_H
#include <stdio.h>
#endif

inline void MsgBox(char *szCaption, char *szFormat, ...)
/* 
// for borlandc
{
    char szBuffer[256];
    char *pArguments;

    pArguments = (char*)&szFormat + sizeof(szFormat);
    vsprintf(szBuffer, szFormat, pArguments);
    MessageBox(NULL, szBuffer, szCaption, MB_OK|MB_TASKMODAL);
}
*/
// for WATCOM
{
    va_list arglist;
    char szBuffer[256];
    
    va_start( arglist, szFormat );
    vsprintf( szBuffer, szFormat, arglist );
    va_end( arglist );
    MessageBox(NULL, szBuffer, szCaption, MB_OK|MB_TASKMODAL);
}

#endif

