// file: packing.cpp
// bit-oriented functions for reading and writting single bits on a file

#include "packing.h"

int Pack(const int size, DWORD value, FILE* foutf)
// This procedure is based on a work by Yuval Fisher ver. 0.03 3/14/94
{
  int i;
  static int ptr = 1, // how many bits are packed in sum so far
             sum = 0, // packed bits
             num_of_packed_bytes = 0; // total bytes in file

  // Reinitialize for successive encodings
  if (size == 0)
  { ptr=1;
    sum=0;
    num_of_packed_bytes=0;
  }
  // if size == -1 we are at the end, so write out what is left
  if (size == -1 && ptr != 1)
  {
    fputc(sum<<(8-ptr), foutf);
    ++num_of_packed_bytes;
    return(0);
  }

  // size == -2 means we want to know how mny bytes we have written
  if (size == -2) return(num_of_packed_bytes);

  for (i=0; i<size; ++i, ++ptr, value = value>>1, sum = sum<<1)
    {
    if (value & 1) sum |= 1;
    if (ptr == 8)
      {
      fputc(sum,foutf);
      ++num_of_packed_bytes;
      sum=0;
      ptr=0;
      }
    }
  return (size); // or any other...
}

DWORD Unpack(const int size, FILE * fin)
// This procedure is based on a work by Yuval Fisher ver. 0.05 10/10/94
{
  int i;
  DWORD value = 0;
  static int ptr = 1, //how many bits are packed in sum so far
             sum;

  // size == -2 means we initialize things
  if (size == -2)
    {
    value = 0;
    ptr = 1;
    sum = fgetc(fin);
    sum <<= 1;
    return 0;
    }

  // size == -1 means we want to peek at the next bit without advancing the pointer
  if (size == -1)
    return((DWORD)((sum&256)>>8));

  for (i=0; i<size; ++i, ++ptr, sum <<= 1)
    {
    if (sum & 256) value |= 1ul<<i;
    if (ptr == 8)
      {
      sum = fgetc(fin);
      ptr=0;
      }
    }
  return value;
}
