// file: rcencdec.h
// Common definitions for rcencode, rcdecode
// Written by G.Pulcini
// Last revised 1995/4/19  Rev 0.35

#ifndef __RCENCDEC_H__
#define __RCENCDEC_H__

#ifndef __KERNEL_H__
#include "kernel.h"
#endif

inline WORD bitsof(WORD x) { return (WORD) ceil(log(x)/log(2.0)); }

inline void YIQtoRGB(int Y, int I, int Q, int &R, int &G, int &B)
{
  I -= 127;
  Q -= 127;
  R = Y+1.13918*I+0.648372*Q;
  G = Y-0.323726*I-0.67663*Q;
  B = Y-1.32095*I+1.7835*Q;
}

inline void RGBtoYIQ(int R, int G, int B, int &Y, int &I, int &Q)
{
  // Time taken: 7745 ms
  Y = 0.5 + 0.299*R + 0.587*G + 0.114*B;
  I = 0.5*R - 0.2307047*G - 0.2692953*B + 128.0;
  Q = 0.2026769*R - 0.5*G + 0.2973231*B + 128.0;
}

void CombineYIQBlock2RGB(PTBLOCK BlockY, PTBLOCK BlockI, PTBLOCK BlockQ, PTBLOCK BlockRGB, WORD N);
void GetBlock( HPBYTE lpcY, WORD wbits, WORD N, int iso,
                      double alpha, double beta,
                      WORD id0, WORD jd0, BYTE * Block);



#endif
